/*
 * Linux dependent Header
 *
 */

#include<unistd.h>
#include<stdio.h>
#include<stdlib.h>
#include<sys/io.h>
#include<string.h>

/* Bonnet */

#include<ide.h>
#include<types.h>
#include<stat.h>
#include<dirent.h>
#include<ext2.h>
#include<vfs.h>
#include<blkdev.h>
#include<file.h>
#include<buffer.h>

/* namei.c */
inode_t find_inode_by_name(inode_t base,char *dir);
inode_t namei(char *path);

/* inode.c */
struct ext2_inode* iget(inode_t inode);

/* debug.c */
void print_group_descriptor(struct ext2_group_desc *gd);
void print_super_block(struct ext2_super_block *sb);

/* mount.c */
int mount(int drvno,int partno);
void ext2_init();

/* buffer.c */
struct buffer_head *select_low_priority();
void plus_priority(struct buffer_head *tmp);
int insert_buffer(int blkno,char *buf);
struct buffer_head *find_buffer(int blkno);
struct buffer_head *_nfind(int blkno);
static int delete_buffer(struct buffer_head *tmp);
int getblk(int block_num,char *buf,int count);
void init_buffer_cache();

// for test
void plus_priority(struct buffer_head *tmp);
struct buffer_head *select_low_priority();

/* read_write.c */
int bread(int block,char *buf,int count);
int sread(int sector,char *buf,int count);

/* bitmap.c */
int check_block_bitmap(int blkno);
int check_inode_bitmap(int inodno);

/* dir.c */
DIR *opendir(char *pathname);
struct dirent *readdir(DIR *dp);

/* stat.c */
int stat(char *pathname,struct stat *buf);

/*****************/
/* Device Driver */
/*****************/

/* ide.c */
int ide_read(int lba,char *buf,int count);
int ide_write(int lba,char *buf,int count);
void init_ide_driver();

/* rd.c */
int rd_read(int offset,char *buf,int count);
int rd_write(int offset,char *buf,int count);
void init_rd_driver();

/* blkdev.c */
void register_blkdev(int major,struct blkdev_operations *blk_op,char *buffer);
void unregister_blkdev(int major);


/* Macro */

#define sdelay() asm("nop;nop;nop;")
#define new_balloc(count) (char *)malloc(count * BLKSIZE)
